<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleHangingMuscle.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleHangingMuscle_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleHangingMuscle.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This example optimizes the motion of a point mass actuated by a single muscle and shows you how to use the AnalyzeTool and a metabolic probe with a MocoSolution.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># OpenSim Moco: exampleHangingMuscle.py                                      #</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Copyright (c) 2020 Stanford University and the Authors                     #</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"># Author(s): Christopher Dembia                                              #</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"># Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    #</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"># not use this file except in compliance with the License. You may obtain a  #</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"># copy of the License at http://www.apache.org/licenses/LICENSE-2.0          #</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># Unless required by applicable law or agreed to in writing, software        #</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          #</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># See the License for the specific language governing permissions and        #</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"># limitations under the License.                                             #</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"># This example includes a point mass hanging by a muscle (+x is downward),</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"># and shows how to use MocoStudy with a model that includes a muscle.</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"># Additionally, this example shows how to use OpenSim&#39;s Analyses with a</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"># MocoSolution.</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"># The trajectory optimization problem is to lift the point mass by a small</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"># distance in minimum time.</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">def </span>createHangingMuscleModel(ignore_activation_dynamics,</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;                             ignore_tendon_compliance):</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    model = osim.Model()</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    model.setName(<span class="stringliteral">&quot;hanging_muscle&quot;</span>)</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    model.set_gravity(osim.Vec3(9.81, 0, 0))</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    body = osim.Body(<span class="stringliteral">&quot;body&quot;</span>, 0.5, osim.Vec3(0), osim.Inertia(1))</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    model.addComponent(body)</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="comment"># Allows translation along x.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    joint = osim.SliderJoint(<span class="stringliteral">&quot;joint&quot;</span>, model.getGround(), body)</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    coord = joint.updCoordinate()</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    coord.setName(<span class="stringliteral">&quot;height&quot;</span>)</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    model.addComponent(joint)</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="comment"># The point mass is supported by a muscle.</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="comment"># The DeGrooteFregly2016Muscle is the only muscle model in OpenSim that</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="comment"># has been tested with Moco.</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    actu = osim.DeGrooteFregly2016Muscle()</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    actu.setName(<span class="stringliteral">&quot;muscle&quot;</span>)</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    actu.set_max_isometric_force(30.0)</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    actu.set_optimal_fiber_length(0.10)</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    actu.set_tendon_slack_length(0.05)</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    actu.set_tendon_strain_at_one_norm_force(0.10)</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    actu.set_ignore_activation_dynamics(ignore_activation_dynamics)</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    actu.set_ignore_tendon_compliance(ignore_tendon_compliance)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    actu.set_fiber_damping(0.01)</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment"># The DeGrooteFregly2016Muscle is the only muscle model in OpenSim that</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="comment"># can express its tendon compliance dynamics using an implicit</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="comment"># differential equation.</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    actu.set_tendon_compliance_dynamics_mode(<span class="stringliteral">&quot;implicit&quot;</span>)</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    actu.set_max_contraction_velocity(10)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    actu.set_pennation_angle_at_optimal(0.10)</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    actu.addNewPathPoint(<span class="stringliteral">&quot;origin&quot;</span>, model.updGround(), osim.Vec3(0))</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    actu.addNewPathPoint(<span class="stringliteral">&quot;insertion&quot;</span>, body, osim.Vec3(0))</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    model.addForce(actu)</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="comment"># Add metabolics probes: one for the total metabolic rate,</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="comment"># and one for each term in the metabolics model.</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    probe = osim.Umberger2010MuscleMetabolicsProbe()</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    probe.setName(<span class="stringliteral">&quot;metabolics&quot;</span>)</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    probe.addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5)</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    model.addProbe(probe)</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    probe = osim.Umberger2010MuscleMetabolicsProbe()</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    probe.setName(<span class="stringliteral">&quot;activation_maintenance_rate&quot;</span>)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    probe.set_activation_maintenance_rate_on(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    probe.set_shortening_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    probe.set_basal_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    probe.set_mechanical_work_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    probe.addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5)</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    model.addProbe(probe)</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    probe = osim.Umberger2010MuscleMetabolicsProbe()</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    probe.setName(<span class="stringliteral">&quot;shortening_rate&quot;</span>)</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    probe.set_activation_maintenance_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    probe.set_shortening_rate_on(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    probe.set_basal_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    probe.set_mechanical_work_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    probe.addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5)</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    model.addProbe(probe);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    probe = osim.Umberger2010MuscleMetabolicsProbe()</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    probe.setName(<span class="stringliteral">&quot;basal_rate&quot;</span>)</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    probe.set_activation_maintenance_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    probe.set_shortening_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    probe.set_basal_rate_on(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    probe.set_mechanical_work_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    probe.addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5)</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    model.addProbe(probe)</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160; </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    probe = osim.Umberger2010MuscleMetabolicsProbe()</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    probe.setName(<span class="stringliteral">&quot;mechanical_work_rate&quot;</span>)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    probe.set_activation_maintenance_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    probe.set_shortening_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    probe.set_basal_rate_on(<span class="keyword">False</span>)</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    probe.set_mechanical_work_rate_on(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    probe.addMuscle(<span class="stringliteral">&quot;muscle&quot;</span>, 0.5)</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    model.addProbe(probe)</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    body.attachGeometry(osim.Sphere(0.05))</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    model.finalizeConnections()</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordflow">return</span> model</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;ignore_activation_dynamics = <span class="keyword">False</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;ignore_tendon_compliance = <span class="keyword">False</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;model = createHangingMuscleModel(ignore_activation_dynamics,</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                                 ignore_tendon_compliance)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;model.printToXML(<span class="stringliteral">&quot;hanging_muscle.osim&quot;</span>)</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;study = osim.MocoStudy()</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;problem = study.updProblem()</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;problem.setModelAsCopy(model)</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;problem.setTimeBounds(0, [0.05, 1.0])</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;problem.setStateInfo(<span class="stringliteral">&quot;/joint/height/value&quot;</span>, [0.14, 0.16], 0.15, 0.14)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;problem.setStateInfo(<span class="stringliteral">&quot;/joint/height/speed&quot;</span>, [-1, 1], 0, 0)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;problem.setControlInfo(<span class="stringliteral">&quot;/forceset/muscle&quot;</span>, [0.01, 1])</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment"># Initial state constraints/costs.</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> ignore_activation_dynamics:</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    initial_activation = osim.MocoInitialActivationGoal()</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    problem.addGoal(initial_activation)</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    initial_activation.setName(<span class="stringliteral">&quot;initial_activation&quot;</span>)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> ignore_tendon_compliance:</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    initial_equilibrium = osim.MocoInitialVelocityEquilibriumDGFGoal()</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    problem.addGoal(initial_equilibrium)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    initial_equilibrium.setName(<span class="stringliteral">&quot;initial_velocity_equilibrium&quot;</span>)</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="comment"># The problem converges in fewer iterations when this goal is in cost mode.</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    initial_equilibrium.setMode(<span class="stringliteral">&quot;cost&quot;</span>)</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    initial_equilibrium.setWeight(0.001)</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;problem.addGoal(osim.MocoFinalTimeGoal())</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;solver = study.initCasADiSolver()</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;solver.set_num_mesh_intervals(25)</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;solver.set_multibody_dynamics_mode(<span class="stringliteral">&quot;implicit&quot;</span>)</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;solver.set_optim_convergence_tolerance(1e-4)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;solver.set_optim_constraint_tolerance(1e-4)</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160; </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;solution = study.solve()</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;osim.STOFileAdapter.write(solution.exportToStatesTable(),</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                      <span class="stringliteral">&quot;exampleHangingMuscle_states.sto&quot;</span>)</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;osim.STOFileAdapter.write(solution.exportToControlsTable(),</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;                      <span class="stringliteral">&quot;exampleHangingMuscle_controls.sto&quot;</span>)</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment"># Conduct an analysis using MuscleAnalysis and ProbeReporter.</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="comment"># Create an AnalyzeTool setup file.</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;analyze = osim.AnalyzeTool()</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;analyze.setName(<span class="stringliteral">&quot;analyze&quot;</span>)</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;analyze.setModelFilename(<span class="stringliteral">&quot;hanging_muscle.osim&quot;</span>)</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;analyze.setStatesFileName(<span class="stringliteral">&quot;exampleHangingMuscle_states.sto&quot;</span>)</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;analyze.updAnalysisSet().cloneAndAppend(osim.MuscleAnalysis())</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;analyze.updAnalysisSet().cloneAndAppend(osim.ProbeReporter())</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;analyze.updControllerSet().cloneAndAppend(</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    osim.PrescribedController(<span class="stringliteral">&quot;exampleHangingMuscle_controls.sto&quot;</span>))</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;analyze.printToXML(<span class="stringliteral">&quot;exampleHangingMuscle_AnalyzeTool_setup.xml&quot;</span>)</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="comment"># Run the analysis.</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;analyze = osim.AnalyzeTool(<span class="stringliteral">&quot;exampleHangingMuscle_AnalyzeTool_setup.xml&quot;</span>)</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;analyze.run()</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160; </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;table_force = osim.TimeSeriesTable(</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="stringliteral">&quot;analyze_MuscleAnalysis_ActiveFiberForce.sto&quot;</span>)</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;table_velocity = osim.TimeSeriesTable(</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="stringliteral">&quot;analyze_MuscleAnalysis_FiberVelocity.sto&quot;</span>)</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;time = table_force.getIndependentColumn()</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;force = table_force.getDependentColumn(<span class="stringliteral">&quot;muscle&quot;</span>).to_numpy()</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;velocity = table_velocity.getDependentColumn(<span class="stringliteral">&quot;muscle&quot;</span>).to_numpy()</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160; </div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="comment"># Plot the terms of the metabolics model, and compare the metabolics model&#39;s</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="comment"># mechanical work rate to the mechanical work rate computed using the</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="comment"># MuscleAnalysis.</span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;plot = <span class="keyword">False</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="comment"># The following environment variable is set during automated testing.</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="keywordflow">if</span> os.getenv(<span class="stringliteral">&#39;OPENSIM_USE_VISUALIZER&#39;</span>) != <span class="stringliteral">&#39;0&#39;</span>:</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keywordflow">try</span>:</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keyword">import</span> pylab <span class="keyword">as</span> pl</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        plot = <span class="keyword">True</span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keywordflow">except</span>:</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        print(<span class="stringliteral">&#39;Skipping plotting&#39;</span>)</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160; </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="keywordflow">if</span> plot:</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    pl.plot(time, force * -velocity,</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            label=<span class="stringliteral">&#39;active_fiber_force * fiber_velocity&#39;</span>, lw=4)</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160; </div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    table_metabolics = osim.TimeSeriesTable(<span class="stringliteral">&quot;analyze_ProbeReporter_probes.sto&quot;</span>)</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    time = table_metabolics.getIndependentColumn()</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    metabolics_total_rate = table_metabolics.getDependentColumn(</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <span class="stringliteral">&quot;metabolics_TOTAL&quot;</span>).to_numpy()</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    pl.plot(time, metabolics_total_rate, label=<span class="stringliteral">&#39;total metabolic rate&#39;</span>)</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160; </div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    mech_work_rate = table_metabolics.getDependentColumn(</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="stringliteral">&quot;mechanical_work_rate_TOTAL&quot;</span>).to_numpy()</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    pl.plot(time, mech_work_rate, label=<span class="stringliteral">&#39;mechanical work rate&#39;</span>)</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160; </div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    activation_maintenance_rate = table_metabolics.getDependentColumn(</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="stringliteral">&quot;activation_maintenance_rate_TOTAL&quot;</span>).to_numpy()</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    pl.plot(time, activation_maintenance_rate,</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            label=<span class="stringliteral">&#39;activation maintenance rate&#39;</span>)</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    shortening_rate = table_metabolics.getDependentColumn(</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="stringliteral">&quot;shortening_rate_TOTAL&quot;</span>).to_numpy()</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    pl.plot(time, shortening_rate, label=<span class="stringliteral">&#39;shortening rate&#39;</span>)</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160; </div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    basal_rate = table_metabolics.getDependentColumn(</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="stringliteral">&quot;basal_rate_TOTAL&quot;</span>).to_numpy()</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    pl.plot(time, basal_rate, label=<span class="stringliteral">&#39;basal rate&#39;</span>)</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    pl.legend()</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    pl.show()</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160; </div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
